package atVM;

import java.util.ArrayList;
import java.util.Collection;

import mobileAgent.GeneralMobileAgent;
import residenceAgent.ResidenceAgent;

public class TestInitAndReleaseMA implements IApplication {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		new TestInitAndReleaseMA().releaseMobileAgent(args);
	}

	public void normalStart(String[] args) {
		new AFrame(args);
	}

	public void releaseMobileAgent(String[] args) {
		AFrame aFrame1 = new AFrame(args);
		ResidenceAgent ra1 = aFrame1.getResidenceAgent();
		System.out.println("Residence Agent Initialized: \""
				+ ra1.getResidenceAgentName() + "\"");
		String appName = "test";
		System.out.println("ra1.register() result: ");
		try {
			ra1.register(appName, new TestInitAndReleaseMA());
		} catch (ApplicationExistsException e) {
			e.printStackTrace();
		}
		System.out.println("ra1.getCurrentTime() result: "
				+ ra1.getCurrentTime());
		// System.out.println("ra1.getAgentList() result: " +
		// ra1.getAgentList());
		GeneralMobileAgent ma1 = aFrame1.createMobileAgent();
		System.out.println("mobile agent created: " + ma1.getId());
		ma1.getApplicationSpecificMobileAgent("ipAddr", "1");
		ma1.setOwner(ra1.getResidenceAgentName());
		ma1.setAppName(appName);
		ma1.setDelay(5000);
		ma1.setTransitionMode("allNodes");
		Collection<String> set = new ArrayList<String>();
		ma1.setTransitionSet(set);
		ma1.execute();
		ma1.transitToNextNode(true, true);
	}

	// The new instance will be created at runtime, thus note that this method
	// currently cannot reference other properties...
	public void mobileAgentComeBack(String id, String data) {
		String[] array = data.split("#takenAwayDataSplit#");
		String text = "mobile agent executing result: \n";
		for (int i = 0; i < array.length; i++) {
			String line = array[i];
			text = text + line + "\n";
		}
		System.out.println("return result: " + text);
	}
}
